"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.KeycloakGuard = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const graphql_1 = require("@nestjs/graphql");
const passport_1 = require("@nestjs/passport");
const constants_1 = require("../constants");
let KeycloakGuard = class KeycloakGuard extends passport_1.AuthGuard('keycloak') {
    constructor(reflector) {
        super();
        this.reflector = reflector;
    }
    getRequest(context) {
        const isRest = context.getType() === 'http';
        const request = isRest
            ? context.switchToHttp().getRequest()
            : graphql_1.GqlExecutionContext.create(context).getContext().req;
        request.isRest = isRest;
        const handler = context.getHandler();
        const hasProtectedDecorator = this.reflector.get(constants_1.PROTECTED, handler);
        if (hasProtectedDecorator) {
            request.protectionType = constants_1.PROTECTED;
            return request;
        }
        const scopeDecorator = this.reflector.get(constants_1.HAS_SCOPE, handler);
        if (scopeDecorator) {
            request.protectionType = constants_1.HAS_SCOPE;
            request.resource = isRest
                ? request.params[scopeDecorator]
                : graphql_1.GqlExecutionContext.create(context).getArgs()[scopeDecorator];
            request.scope = context.getHandler().name;
            return request;
        }
        const roleDecorator = this.reflector.get(constants_1.HAS_ROLE, handler);
        if (roleDecorator) {
            request.protectionType = constants_1.HAS_ROLE;
            request.roles = Array.isArray(roleDecorator) ? roleDecorator : [roleDecorator];
            return request;
        }
        return request;
    }
};
KeycloakGuard = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [core_1.Reflector])
], KeycloakGuard);
exports.KeycloakGuard = KeycloakGuard;
//# sourceMappingURL=keycloak.guard.js.map